-- MySQL dump 8.23
--
-- Host: localhost    Database: test_fam
---------------------------------------------------------
-- Server version	3.23.58

--
-- Table structure for table `@@DB_MAIN_PREFIX@@census`
--

CREATE TABLE `@@DB_MAIN_PREFIX@@census` (
  `person_id` smallint(5) unsigned zerofill NOT NULL default '00000',
  `census` mediumint(4) NOT NULL default '0',
  `schedule` varchar(20) NOT NULL default '',
  `address` varchar(70) NOT NULL default '',
  `condition` enum('','married','unmarried','widowed') NOT NULL default 'unmarried',
  `age` tinyint(4) unsigned NOT NULL default '0',
  `profession` varchar(45) NOT NULL default '',
  `where_born` varchar(40) NOT NULL default '',
  `other_details` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`person_id`,`census`)
) TYPE=MyISAM;

--
-- Dumping data for table `@@DB_MAIN_PREFIX@@census`
--



--
-- Table structure for table `@@DB_MAIN_PREFIX@@census_years`
--

CREATE TABLE `@@DB_MAIN_PREFIX@@census_years` (
  `census_id` mediumint(9) NOT NULL auto_increment,
  `country` varchar(20) NOT NULL default '',
  `year` smallint(4) NOT NULL default '0',
  `available` enum('Y','N') NOT NULL default 'Y',
  PRIMARY KEY  (`census_id`),
  KEY `available` (`available`)
) TYPE=MyISAM;

--
-- Dumping data for table `@@DB_MAIN_PREFIX@@census_years`
--


INSERT INTO `@@DB_MAIN_PREFIX@@census_years` VALUES (1,'British Isles',1841,'Y');
INSERT INTO `@@DB_MAIN_PREFIX@@census_years` VALUES (2,'British Isles',1851,'Y');
INSERT INTO `@@DB_MAIN_PREFIX@@census_years` VALUES (3,'British Isles',1861,'Y');
INSERT INTO `@@DB_MAIN_PREFIX@@census_years` VALUES (4,'British Isles',1871,'Y');
INSERT INTO `@@DB_MAIN_PREFIX@@census_years` VALUES (5,'British Isles',1881,'Y');
INSERT INTO `@@DB_MAIN_PREFIX@@census_years` VALUES (6,'British Isles',1891,'Y');
INSERT INTO `@@DB_MAIN_PREFIX@@census_years` VALUES (7,'British Isles',1901,'Y');
INSERT INTO `@@DB_MAIN_PREFIX@@census_years` VALUES (8,'USA',1790,'Y');
INSERT INTO `@@DB_MAIN_PREFIX@@census_years` VALUES (9,'USA',1800,'Y');
INSERT INTO `@@DB_MAIN_PREFIX@@census_years` VALUES (10,'USA',1810,'Y');
INSERT INTO `@@DB_MAIN_PREFIX@@census_years` VALUES (11,'USA',1820,'Y');
INSERT INTO `@@DB_MAIN_PREFIX@@census_years` VALUES (12,'USA',1830,'Y');
INSERT INTO `@@DB_MAIN_PREFIX@@census_years` VALUES (13,'USA',1840,'Y');
INSERT INTO `@@DB_MAIN_PREFIX@@census_years` VALUES (14,'USA',1850,'Y');
INSERT INTO `@@DB_MAIN_PREFIX@@census_years` VALUES (15,'USA',1860,'Y');
INSERT INTO `@@DB_MAIN_PREFIX@@census_years` VALUES (16,'USA',1870,'Y');
INSERT INTO `@@DB_MAIN_PREFIX@@census_years` VALUES (17,'USA',1880,'Y');
INSERT INTO `@@DB_MAIN_PREFIX@@census_years` VALUES (18,'USA',1890,'Y');
INSERT INTO `@@DB_MAIN_PREFIX@@census_years` VALUES (19,'USA',1900,'Y');
INSERT INTO `@@DB_MAIN_PREFIX@@census_years` VALUES (20,'USA',1910,'Y');
INSERT INTO `@@DB_MAIN_PREFIX@@census_years` VALUES (21,'USA',1920,'Y');
INSERT INTO `@@DB_MAIN_PREFIX@@census_years` VALUES (22,'USA',1930,'Y');
INSERT INTO `@@DB_MAIN_PREFIX@@census_years` VALUES (23,'Canada',1842,'Y');
INSERT INTO `@@DB_MAIN_PREFIX@@census_years` VALUES (24,'Canada',1848,'Y');
INSERT INTO `@@DB_MAIN_PREFIX@@census_years` VALUES (25,'Canada',1851,'Y');
INSERT INTO `@@DB_MAIN_PREFIX@@census_years` VALUES (26,'Canada',1861,'Y');
INSERT INTO `@@DB_MAIN_PREFIX@@census_years` VALUES (27,'Canada',1871,'Y');
INSERT INTO `@@DB_MAIN_PREFIX@@census_years` VALUES (28,'Canada',1881,'Y');
INSERT INTO `@@DB_MAIN_PREFIX@@census_years` VALUES (29,'Canada',1891,'Y');
INSERT INTO `@@DB_MAIN_PREFIX@@census_years` VALUES (30,'Canada',1901,'Y');

--
-- Table structure for table `@@DB_MAIN_PREFIX@@documents`
--

CREATE TABLE `@@DB_MAIN_PREFIX@@documents` (
  `id` smallint(5) unsigned zerofill NOT NULL auto_increment,
  `person_id` smallint(5) unsigned zerofill NOT NULL default '00000',
  `doc_date` date NOT NULL default '0000-00-00',
  `doc_title` varchar(30) NOT NULL default '',
  `doc_description` varchar(60) NOT NULL default '',
  `file_name` varchar(128) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `person_id` (`person_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `@@DB_MAIN_PREFIX@@documents`
--



--
-- Table structure for table `@@DB_MAIN_PREFIX@@images`
--

CREATE TABLE `@@DB_MAIN_PREFIX@@images` (
  `image_id` smallint(5) unsigned zerofill NOT NULL auto_increment,
  `person_id` smallint(5) unsigned zerofill NOT NULL default '00000',
  `title` varchar(30) NOT NULL default '',
  `date` date NOT NULL default '0000-00-00',
  `description` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`image_id`),
  KEY `idx_show_gallery` (`person_id`,`date`)
) TYPE=MyISAM;

--
-- Dumping data for table `@@DB_MAIN_PREFIX@@images`
--


INSERT INTO `@@DB_MAIN_PREFIX@@images` VALUES (10000,00000,'','0000-00-00','');

--
-- Table structure for table `@@DB_MAIN_PREFIX@@people`
--

CREATE TABLE `@@DB_MAIN_PREFIX@@people` (
  `person_id` smallint(5) unsigned zerofill NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `surname` varchar(20) NOT NULL default '',
  `suffix` varchar(10) NOT NULL default '',
  `date_of_birth` date NOT NULL default '0000-00-00',
  `birth_cert` enum('Y','N') NOT NULL default 'N',
  `birth_place` varchar(50) NOT NULL default '',
  `date_of_death` date NOT NULL default '0000-00-00',
  `death_cert` enum('Y','N') NOT NULL default 'N',
  `death_reason` varchar(50) NOT NULL default '',
  `gender` enum('M','F') NOT NULL default 'M',
  `mother_id` smallint(5) unsigned zerofill NOT NULL default '00000',
  `father_id` smallint(5) unsigned zerofill NOT NULL default '00000',
  `narrative` longtext NOT NULL,
  `updated` timestamp(14) NOT NULL,
  PRIMARY KEY  (`person_id`),
  KEY `gender` (`gender`),
  KEY `surname` (`surname`),
  KEY `idx_list_peeps1` (`surname`,`name`,`date_of_birth`,`person_id`),
  KEY `idx_list_peeps2` (`gender`,`surname`,`name`,`date_of_birth`,`person_id`),
  KEY `idx_children` (`date_of_birth`,`mother_id`,`father_id`,`person_id`,`name`,`date_of_death`)
) TYPE=MyISAM;

--
-- Dumping data for table `@@DB_MAIN_PREFIX@@people`
--


INSERT INTO `@@DB_MAIN_PREFIX@@people` VALUES (00001,'Alpha Male','Male','','0000-00-00','N','','0000-00-00','N','','M',00000,00000,'',20050422185856);

--
-- Table structure for table `@@DB_MAIN_PREFIX@@spouses`
--

CREATE TABLE `@@DB_MAIN_PREFIX@@spouses` (
  `groom_id` smallint(5) unsigned zerofill NOT NULL default '00000',
  `bride_id` smallint(5) unsigned zerofill NOT NULL default '00000',
  `marriage_date` date NOT NULL default '0000-00-00',
  `marriage_cert` enum('Y','N') NOT NULL default 'N',
  `marriage_place` varchar(50) NOT NULL default '0',
  `dissolve_date` date NOT NULL default '0000-00-00',
  `dissolve_reason` char(1) NOT NULL default '',
  PRIMARY KEY  (`marriage_date`,`groom_id`,`bride_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `@@DB_MAIN_PREFIX@@spouses`
--



--
-- Table structure for table `@@DB_MAIN_PREFIX@@tracking`
--

CREATE TABLE `@@DB_MAIN_PREFIX@@tracking` (
  `person_id` smallint(5) unsigned zerofill NOT NULL default '00000',
  `email` varchar(128) NOT NULL default '',
  `key` varchar(32) NOT NULL default '',
  `action` enum('sub','unsub') NOT NULL default 'sub',
  `expires` datetime default NULL,
  UNIQUE KEY `person_id` (`person_id`,`email`)
) TYPE=MyISAM;

--
-- Dumping data for table `@@DB_MAIN_PREFIX@@tracking`
--



--
-- Table structure for table `@@DB_MAIN_PREFIX@@users`
--

CREATE TABLE `@@DB_MAIN_PREFIX@@users` (
  `id` smallint(6) NOT NULL auto_increment,
  `username` varchar(10) NOT NULL default '',
  `password` varchar(32) NOT NULL default '',
  `email` varchar(128) NOT NULL default '',
  `admin` enum('Y','N') NOT NULL default 'N',
  `edit` enum('Y','N') NOT NULL default 'N',
  `restrictdate` date NOT NULL default '0000-00-00',
  `style` varchar(40) NOT NULL default '',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `@@DB_MAIN_PREFIX@@users`
--


INSERT INTO `@@DB_MAIN_PREFIX@@users` VALUES (43,'@@ADMIN_NAME@@','@@ADMIN_PASSWORD@@','@@ADMIN_EMAIL@@','Y','Y','1910-01-01','default.css.php');

